// Code by L. Petit, Nov 2016

import java.util.List;

int u=20; //unit of the lattice. A smaller u means a finer grid 
int speed=5; //speed of the animation
int w=1280; //width of the screen
int h=800; //height of the screen

int curX;
int curY;
int newX;
int newY;
int iterLERW=0;
ArrayList<Integer> LERWX= new ArrayList();
ArrayList<Integer> LERWY= new ArrayList();
ArrayList<Integer> visitedX= new ArrayList();
ArrayList<Integer> visitedY= new ArrayList();
int startX;
int startY;
Boolean ended=false;

//all points are of the form u*(n,m) where u is the unit
void setup() {
  fullScreen();
  background(0);
  curX=u;
  curY=u;
  startX=u;
  startY=u;
  LERWX.add(curX);
  LERWY.add(curY);
  visitedX.add(2*u);
  visitedY.add(u);
}

void draw() {
  for (int j=0; j<speed; j++) {
    addPoint();
  }
}

int isin(int x, int y) {
  for (int k=0; k<LERWX.size(); k++) {
    if (LERWX.get(k) == x && LERWY.get(k) == y) {
      return k;
    }
  }
  return -1;
}

Boolean visited(int x, int y) {
  for (int k=0; k<visitedX.size(); k++) {
    if (x == visitedX.get(k) && y == visitedY.get(k)) return true;
  }
  return false;
}

void eraseLoop(int index) {
  if (index!=-1) {
    stroke(0);
    for (int l=LERWX.size()-1; l>index; l--) {
      line(LERWX.get(l), LERWY.get(l), LERWX.get(l-1), LERWY.get(l-1));
      LERWX.remove(l);
      LERWY.remove(l);
    }
  }
}

void validPath() {
  for (int k=0; k<LERWX.size()-1; k++) {
    stroke(255);
    line(LERWX.get(k), LERWY.get(k), LERWX.get(k+1), LERWY.get(k+1));
    visitedX.add(LERWX.get(k));
    visitedY.add(LERWY.get(k));
  }
  LERWX.clear();
  LERWY.clear();
}

void addPoint() {
  Boolean bool=false;
  if (ended==false) {
    if (visited(curX, curY)) {
      validPath();
      while (visited(startX, startY)==true) {
        startX+=u;
        if (startX>w-u) {
          startX=u;
          startY+=u;
          if (startY>h-u) ended=true;
        }
      }
      LERWX.add(startX);
      LERWY.add(startY);
      curX=startX;
      curY=startY;
    } else {
      while (newX<u || newX>w-u || newY<u || newY>h-u || bool==false) {
        bool=true;
        newX=curX;
        newY=curY;
        if (random(1)<0.5) {
          if (random(1)<0.5) newX=curX+u;
          else newX=curX-u;
        } else {
          if (random(1)<0.5) newY=curY+u;
          else newY=curY-u;
        }
      }
      LERWX.add(newX);
      LERWY.add(newY);
      stroke(0, 255, 0);
      line(curX, curY, newX, newY);
      iterLERW++;
      curX=newX;
      curY=newY;
      eraseLoop(isin(curX, curY));
    }
  }
}